#ifdef USAVE

#include "USApi.h"
#include "USApi_idd.h"
#include "USApiDefs.h"

#include "USave.h"
#include "DoomDef.h"

#define sz_VERSION "0.8"
#define YEAR		1999
#define MONTH		3
#define DAY			9

typedef struct
{
	char    *name;
	int     *location;
	int     defaultvalue;
	int     scantranslate;      // PC scan code hack
	int     untranslated;       // lousy hack
} default_t;

extern  int     key_right, key_left, key_up, key_down;
extern  int     key_strafeleft, key_straferight;
extern  int     key_fire, key_use, key_strafe, key_speed;
extern	int		key_flyup, key_flydown, key_flycenter;
extern	int		key_lookup, key_lookdown, key_lookcenter;
extern	int		key_invleft, key_invright, key_useartifact;

extern  int         mousebfire;
extern  int         mousebstrafe;
extern  int         mousebforward;

extern  int         joybfire;
extern  int         joybstrafe;
extern  int         joybuse;
extern  int         joybspeed;
extern  int screenblocks;
extern int snd_Channels,snd_MaxVolume,snd_MusicVolume;
extern int mouseSensitivity;
extern int     usemouse;
extern int     usejoystick,usegamma;

extern char *chat_macros[10];

default_t defaults[] =
{
	{ "mouse_sensitivity", &mouseSensitivity, 5 },

#ifndef __NeXT__
	{ "sfx_volume", &snd_MaxVolume, 10},
	{ "music_volume", &snd_MusicVolume, 10},
#endif

//#ifdef __NeXT__	// MR
	{ "key_right", &key_right, KEY_RIGHTARROW },
	{ "key_left", &key_left, KEY_LEFTARROW },
	{ "key_up", &key_up, KEY_UPARROW },
	{ "key_down", &key_down, KEY_DOWNARROW },
	{ "key_strafeleft", &key_strafeleft, ',' },
	{ "key_straferight", &key_straferight, '.' },
	{ "key_flyup", &key_flyup, 'u' },
	{ "key_flydown", &key_flydown, 'j' },
	{ "key_flycenter", &key_flycenter, 'k' },
	{ "key_lookup", &key_lookup, 'm' },
	{ "key_lookdown", &key_lookdown, 'b' },
	{ "key_lookcenter", &key_lookcenter, 'n' },
	{ "key_invleft", &key_invleft, '[' },
	{ "key_invright", &key_invright, ']' },
	{ "key_useartifact", &key_useartifact, 13 },

	{ "key_fire", &key_fire, ' ', 1 },
	{ "key_use", &key_use, 'x', 1 },
	{ "key_strafe", &key_strafe, 'c', 1 },
	{ "key_speed", &key_speed, 'z', 1 },
//#endif	// MR

	{ "use_mouse", &usemouse, 1 },
	{ "mouseb_fire", &mousebfire, 0 },
	{ "mouseb_strafe", &mousebstrafe, 1 },
	{ "mouseb_forward", &mousebforward, 2 },

	{ "use_joystick", &usejoystick, 0 },
	{ "joyb_fire", &joybfire, 0 },
	{ "joyb_strafe", &joybstrafe, 1 },
	{ "joyb_use", &joybuse, 3 },
	{ "joyb_speed", &joybspeed, 2 },

	{ "screenblocks", &screenblocks, 10 },

#ifndef __NeXT__
	{ "snd_channels", &snd_Channels, 3 },
// MR
/*	{ "snd_musicdevice", &snd_DesiredMusicDevice, 0 },
	{ "snd_sfxdevice", &snd_DesiredSfxDevice, 0 },
	{ "snd_sbport", &snd_SBport, 544 },
	{ "snd_sbirq", &snd_SBirq, -1 },
	{ "snd_sbdma", &snd_SBdma, -1 },
	{ "snd_mport", &snd_Mport, -1 },*/
#endif

	{ "usegamma", &usegamma, 0 },

	{ "chatmacro0", (int *) &chat_macros[0], (int) HUSTR_CHATMACRO0 },
	{ "chatmacro1", (int *) &chat_macros[1], (int) HUSTR_CHATMACRO1 },
	{ "chatmacro2", (int *) &chat_macros[2], (int) HUSTR_CHATMACRO2 },
	{ "chatmacro3", (int *) &chat_macros[3], (int) HUSTR_CHATMACRO3 },
	{ "chatmacro4", (int *) &chat_macros[4], (int) HUSTR_CHATMACRO4 },
	{ "chatmacro5", (int *) &chat_macros[5], (int) HUSTR_CHATMACRO5 },
	{ "chatmacro6", (int *) &chat_macros[6], (int) HUSTR_CHATMACRO6 },
	{ "chatmacro7", (int *) &chat_macros[7], (int) HUSTR_CHATMACRO7 },
	{ "chatmacro8", (int *) &chat_macros[8], (int) HUSTR_CHATMACRO8 },
	{ "chatmacro9", (int *) &chat_macros[9], (int) HUSTR_CHATMACRO9 }
};

int numdefaults;
char *defaultfile;

typedef int bool;
#define true 1
#define false 0

long m_lSessionCode,m_lEventCode;

void fn_szGetExeName(char *szFullExeName,char *szExeName)
{ char *ptr;
	
	ptr=szFullExeName+strlen(szFullExeName);
	while (*--ptr!='\\');
	strcpy(szExeName,ptr+1);
	*ptr=0;
}

bool US_RegisterGame(IGame *pIGame,char *szPathName,char *szExeName)
{
US_GAME usGame;
US_HANDLE hGame;

	//
	// See if it already exists
	if (IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame) == USLAST)
		{
		IGame_USGameClose(pIGame,hGame);
		return true;
		}

	//
	// Create the game handle
	if (FAILED(IGame_USGameCreate(pIGame,&hGame,&usGame)))
		{
		return false;
		}

	strcpy((char *)usGame.m_cGUID,GUID_GAME);
	strcpy((char *)usGame.m_cName,"WinHeretic");
	strcpy((char *)usGame.m_cDeveloper,"Kokak");
	usGame.m_bModule=FALSE;
	strcpy((char *)usGame.m_cPathname,szPathName);
	strcpy((char *)usGame.m_cFilename,szExeName);

	//
	// Register the game
	if (FAILED(IGame_USGameSet(pIGame,hGame,&usGame)))
		{
		return false;
		}
	if (FAILED(IGame_USGameCommit(pIGame,hGame)))
		{
		return false;
		}
	if (FAILED(IGame_USGameClose(pIGame,hGame)))
		{
		return false;
		}

return true;
}

bool US_RegisterGameVer(IGame *pIGame)
{
US_GAMEVERSION usVersion;
US_HANDLE hGame;
US_HANDLE hVersion;

	//
	// See if it already exists
	if (IGame_USVerQueryGUID(pIGame,(unsigned char *)GUID_GAMEVER,&hVersion) == USLAST)
		{
		IGame_USVerClose(pIGame,hVersion);
		return true;
		}

	//
	// Get a handle to the game
	IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame);

	//
	// Create a version handle
	if (FAILED(IGame_USVerCreate(pIGame,&hVersion,&usVersion)))
		{
		IGame_USGameClose(pIGame,hGame);
		return false;
		}

	//
	// Set the version parameters
	strcpy((char *)usVersion.m_cGUID,GUID_GAMEVER);
	strcpy((char *)usVersion.m_cName,sz_VERSION);
	usVersion.m_dtRelease.m_nYear=1999;
	usVersion.m_dtRelease.m_nMonth=3;
	usVersion.m_dtRelease.m_nDay=9;

	//
	// Register the game version
	if (FAILED(IGame_USVerSet(pIGame,hVersion,&usVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USVerCommit(pIGame,hGame,hVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USVerClose(pIGame,hVersion)))
		{
		return false;
		}
	IGame_USGameClose(pIGame,hGame);

return true;
}

bool US_RegisterSaveVer(IGame *pIGame)
{
US_SAVEGAMEVERSION usVersion;
US_HANDLE hGame;
US_HANDLE hVersion;

	//
	// See if it already exists
	if (IGame_USSaveVerQueryGUID(pIGame,(unsigned char *)GUID_SAVEVER,&hVersion) == USLAST)
		{
		IGame_USSaveVerClose(pIGame,hVersion);
		return true;
		}

	//
	// Get a handle to the game
	IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame);

	//
	// Create a version handle
	if (FAILED(IGame_USSaveVerCreate(pIGame,&hVersion,&usVersion)))
		{
		IGame_USGameClose(pIGame,hGame);
		return false;
		}

	//
	// Set the version parameters
	strcpy((char *)usVersion.m_cGUID,GUID_SAVEVER);
	strcpy((char *)usVersion.m_cName,sz_VERSION);

	//
	// Register the game version
	if (FAILED(IGame_USSaveVerSet(pIGame,hVersion,&usVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USSaveVerCommit(pIGame,hGame,hVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USSaveVerClose(pIGame,hVersion)))
		{
		return false;
		}
	IGame_USGameClose(pIGame,hGame);

return true;
}

bool US_RegisterStatVer(IGame *pIGame)
{
US_STATVERSION usVersion;
US_HANDLE hGame;
US_HANDLE hVersion;

	//
	// See if it already exists
	if (IGame_USStatVerQueryGUID(pIGame,(unsigned char *)GUID_STATVER,&hVersion) == USLAST)
		{
		IGame_USStatVerClose(pIGame,hVersion);
		return true;
		}

	//
	// Get a handle to the game
	IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame);

	//
	// Create a version handle
	if (FAILED(IGame_USStatVerCreate(pIGame,&hVersion,&usVersion)))
		{
		IGame_USGameClose(pIGame,hGame);
		return false;
		}

	//
	// Set the version parameters
	strcpy((char *)usVersion.m_cGUID,GUID_STATVER);
	strcpy((char *)usVersion.m_cName,sz_VERSION);

	//
	// Register the game version
	if (FAILED(IGame_USStatVerSet(pIGame,hVersion,&usVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USStatVerCommit(pIGame,hGame,hVersion)))
		{
		return false;
		}
	if (FAILED(IGame_USStatVerClose(pIGame,hVersion)))
		{
		return false;
		}
	IGame_USGameClose(pIGame,hGame);

return true;
}

bool US_AppRegister(char *szFullExeName)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGame *pIGame;
char szExeName[255];

	fn_szGetExeName(szFullExeName,szExeName);
	
	//
	// Make sure COM is initialized
	CoInitialize(NULL);

	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIGame,(void **)&pIGame);

	if (!US_RegisterGame(pIGame,szFullExeName,szExeName))
		{
		IUniversalSave_Release(pIUS);
		IGame_Release(pIGame);
		return false;
		}
	if (!US_RegisterGameVer(pIGame))
		{
		IUniversalSave_Release(pIUS);
		IGame_Release(pIGame);
		return false;
		}
	if (!US_RegisterSaveVer(pIGame))
		{
		IUniversalSave_Release(pIUS);
		IGame_Release(pIGame);
		return false;
		}
	if (!US_RegisterStatVer(pIGame))
		{
		IUniversalSave_Release(pIUS);
		IGame_Release(pIGame);
		return false;
		}

	//
	// Release the interfaces
	IUniversalSave_Release(pIUS);
	IGame_Release(pIGame);

return true;
}

void US_InitGameSession(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IStatistics *pIStats;
US_HANDLE hSession;
US_GAMESESSION usSession;

	m_lSessionCode=-1;
	m_lEventCode=-1;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIStatistics,(void **)&pIStats);

	//
	// Create the game session
	IStatistics_USSessionCreate(pIStats,&hSession,&usSession);

	strcpy((char *)usSession.m_cGameGUID,GUID_GAME);
	strcpy((char *)usSession.m_cStatVerGUID,GUID_STATVER);

	IStatistics_USSessionSet(pIStats,hSession,&usSession);
	IStatistics_USSessionCommit(pIStats,hSession);

	//
	// Get the session code
	IStatistics_USSessionGet(pIStats,hSession,&usSession);
	m_lSessionCode=usSession.m_lCode;

	IStatistics_USSessionClose(pIStats,hSession);

	//
	// Release the interfaces
	IUniversalSave_Release(pIUS);
	IStatistics_Release(pIUS);
}

void US_TermGameSession(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IStatistics *pIStats;
US_HANDLE hSession;
US_GAMESESSION usSession;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIStatistics,(void **)&pIStats);

	//
	// Create the game session
	if (IStatistics_USSessionCreate(pIStats,&hSession,&usSession) == USEMPTY)
		{
		IUniversalSave_Release(pIUS);
		IStatistics_Release(pIStats);
		return;
		}

	IStatistics_USSessionQueryCode(pIStats,m_lSessionCode,&hSession);
	IStatistics_USSessionSet(pIStats,hSession,&usSession);
	IStatistics_USSessionCommit(pIStats,hSession);

	IStatistics_USSessionClose(pIStats,hSession);

	//
	// Release the interfaces
	IUniversalSave_Release(pIUS);
	IStatistics_Release(pIStats);
}

void US_M_SaveDefaults(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGame *pIGame;
IPlayer *pIPlayer;
IGameStorage *pIStorage;
US_HANDLE hGame;
US_HANDLE hPlayer;
US_HANDLE hFile;
unsigned long ulWritten;

	//
	// Create the interfaces
	CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
	CoCreateInstance(
		&clsidUS,
		NULL,
		CLSCTX_INPROC_SERVER,
		&iidIUniversalSave,
		(void **)&pIUS);
	IUniversalSave_QueryInterface(pIUS,&iidIGame,(void **)&pIGame);
	IUniversalSave_QueryInterface(pIUS,&iidIPlayer,(void **)&pIPlayer);

	//
	// Get a handle to the game
	IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame);
	//
	// Get a handle to the "generic" player
	IPlayer_USPlayerQueryGUID(pIPlayer,(unsigned char *)GUID_GENERIC_PLAYER,&hPlayer);
	//
	// Attach to the storage - This storage is automatically created by the USave framework
	// when the game is registered.
	IGame_USSettingsAttach(pIGame,hGame,hPlayer,&pIStorage);

	//
	// Create a set of organized files to store the settings
	IGameStorage_USCreateFile(pIStorage,(unsigned long)NULL,(unsigned char *)"Keyboard");
	IGameStorage_USCreateFile(pIStorage,(unsigned long)NULL,(unsigned char *)"Mouse");
	IGameStorage_USCreateFile(pIStorage,(unsigned long)NULL,(unsigned char *)"Sound");
	IGameStorage_USCreateFile(pIStorage,(unsigned long)NULL,(unsigned char *)"Misc");

	//
	// Save the keyboard settings
	IGameStorage_USOpenFile(pIStorage,(unsigned long)NULL,(unsigned char *)"Keyboard",USMODE_CREATE,&hFile);

	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_right,sizeof(key_right),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_left,sizeof(key_left),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_up,sizeof(key_up),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_down,sizeof(key_down),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_strafeleft,sizeof(key_strafeleft),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_straferight,sizeof(key_straferight),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_fire,sizeof(key_fire),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_use,sizeof(key_use),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_strafe,sizeof(key_strafe),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_speed,sizeof(key_speed),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_flyup,sizeof(key_flyup),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_flydown,sizeof(key_flydown),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_flycenter,sizeof(key_flycenter),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_lookup,sizeof(key_lookup),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_lookdown,sizeof(key_lookdown),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_lookcenter,sizeof(key_lookcenter),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_invleft,sizeof(key_invleft),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_invright,sizeof(key_invright),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&key_useartifact,sizeof(key_useartifact),&ulWritten);

	IGameStorage_USCloseFile(pIStorage,hFile);

	//
	// Save the mouse settings
	IGameStorage_USOpenFile(pIStorage,
		(unsigned long)NULL,(unsigned char *)"Mouse",USMODE_CREATE,&hFile);

	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mouseSensitivity,sizeof(mouseSensitivity),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&usemouse,sizeof(usemouse),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mousebfire,sizeof(mousebfire),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mousebstrafe,sizeof(mousebstrafe),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mousebforward,sizeof(mousebforward),&ulWritten);
/*	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mouseb1,sizeof(mouseb1),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mouseb2,sizeof(mouseb2),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mouseb3,sizeof(mouseb3),&ulWritten);*/

	IGameStorage_USCloseFile(pIStorage,hFile);

	//
	// Save the sound settings
	IGameStorage_USOpenFile(pIStorage,
		(unsigned long)NULL,(unsigned char *)"Sound",USMODE_CREATE,&hFile);

	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&snd_MaxVolume,sizeof(int),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&snd_MusicVolume,sizeof(int),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&snd_Channels,sizeof(int),&ulWritten);

	IGameStorage_USCloseFile(pIStorage,hFile);

	//
	// Save the misc settings
	IGameStorage_USOpenFile(pIStorage,
		(unsigned long)NULL,(unsigned char *)"Misc",USMODE_CREATE,&hFile);

/*	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&showMessages,sizeof(showMessages),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&always_run,sizeof(always_run),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&swap_stereo,sizeof(swap_stereo),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&mvert,sizeof(mvert),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&keylink,sizeof(keylink),&ulWritten);*/
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&usejoystick,sizeof(usejoystick),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joybfire,sizeof(joybfire),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joybstrafe,sizeof(joybstrafe),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joybuse,sizeof(joybuse),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joybspeed,sizeof(joybspeed),&ulWritten);
	/*IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joyb1,sizeof(joyb1),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joyb2,sizeof(joyb2),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joyb3,sizeof(joyb3),&ulWritten);
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&joyb4,sizeof(joyb4),&ulWritten);*/
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&screenblocks,sizeof(screenblocks),&ulWritten);
	/*IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&detailLevel,sizeof(detailLevel),&ulWritten);*/
	IGameStorage_USWrite(pIStorage,
		hFile,(unsigned char *)&usegamma,sizeof(usegamma),&ulWritten);
	//IGameStorage_USWrite(hFile,(unsigned char *)&numChannels,sizeof(numChannels),&ulWritten);

	IGameStorage_USCloseFile(pIStorage,hFile);

	//
	// Detach and close down the storage
	IGameStorage_USDetach(pIStorage,);
	IGame_USGameClose(pIGame,hGame);
	IPlayer_USPlayerClose(pIPlayer,hPlayer);

	IGameStorage_Release(pIStorage,);
	IGame_Release(pIGame);
	IPlayer_Release(pIPlayer);
	IUniversalSave_Release(pIUS);
}

void US_M_LoadDefaults(void)
{
CLSID clsidUS;
IUniversalSave *pIUS;
IGame *pIGame;
IPlayer *pIPlayer;
IGameStorage *pIStorage;
US_HANDLE hGame;
US_HANDLE hPlayer;
US_HANDLE hFile;
unsigned long ulRead;
HRESULT hResult;
int i;

 //
 // Set the defaults
 numdefaults = sizeof(defaults)/sizeof(defaults[0]);
 for (i=0 ; i<numdefaults ; i++)
  *defaults[i].location = defaults[i].defaultvalue;

 //
 // Create the interfaces
 CLSIDFromProgID(L"UniversalSave.UniversalSave.1",&clsidUS);
 CoCreateInstance(
  &clsidUS,
  NULL,
  CLSCTX_INPROC_SERVER,
  &iidIUniversalSave,
  (void **)&pIUS);
 IUniversalSave_QueryInterface(pIUS,&iidIGame,(void **)&pIGame);
 IUniversalSave_QueryInterface(pIUS,&iidIPlayer,(void **)&pIPlayer);

 //
 // Get a handle to the game
 IGame_USGameQueryGUID(pIGame,(unsigned char *)GUID_GAME,&hGame);
 //
 // Get a handle to the "generic" player
 IPlayer_USPlayerQueryGUID(pIPlayer,(unsigned char
*)GUID_GENERIC_PLAYER,&hPlayer);
 //
 // Attach to the storage
 IGame_USSettingsAttach(pIPlayer,hGame,hPlayer,&pIStorage);

 //
 // Read the keyboard settings
 hResult=IGameStorage_USOpenFile(pIStorage,
  (unsigned long)NULL,(unsigned char *)"Keyboard",USMODE_READWRITE,&hFile);

 if (SUCCEEDED(hResult))
  {
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_right,sizeof(key_right),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_left,sizeof(key_left),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_up,sizeof(key_up),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_down,sizeof(key_down),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_strafeleft,sizeof(key_strafeleft),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_straferight,sizeof(key_straferight),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_fire,sizeof(key_fire),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_use,sizeof(key_use),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_strafe,sizeof(key_strafe),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_speed,sizeof(key_speed),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_flyup,sizeof(key_flyup),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_flydown,sizeof(key_flydown),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_flycenter,sizeof(key_flycenter),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_lookup,sizeof(key_lookup),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_lookdown,sizeof(key_lookdown),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_lookcenter,sizeof(key_lookcenter),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_invleft,sizeof(key_invleft),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_invright,sizeof(key_invright),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&key_useartifact,sizeof(key_useartifact),&ulRead);

  IGameStorage_USCloseFile(pIStorage,hFile);
  }

 //
 // Read the mouse settings
 hResult=IGameStorage_USOpenFile(pIStorage,
  (unsigned long)NULL,(unsigned char *)"Mouse",USMODE_READWRITE,&hFile);

 if (SUCCEEDED(hResult))
  {
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char
*)&mouseSensitivity,sizeof(mouseSensitivity),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&usemouse,sizeof(usemouse),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mousebfire,sizeof(mousebfire),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mousebstrafe,sizeof(mousebstrafe),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mousebforward,sizeof(mousebforward),&ulRead);
 /* IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mouseb1,sizeof(mouseb1),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mouseb2,sizeof(mouseb2),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mouseb3,sizeof(mouseb3),&ulRead);*/

  IGameStorage_USCloseFile(pIStorage,hFile);
  }

 //
 // Read the sound settings
 hResult=IGameStorage_USOpenFile(pIStorage,
  (unsigned long)NULL,(unsigned char *)"Sound",USMODE_READWRITE,&hFile);

 if (SUCCEEDED(hResult))
  {
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&snd_MaxVolume,sizeof(int),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&snd_MusicVolume,sizeof(int),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&snd_Channels,sizeof(int),&ulRead);

  IGameStorage_USCloseFile(pIStorage,hFile);
  }

 //
 // Read the misc settings
 hResult=IGameStorage_USOpenFile(pIStorage,
  (unsigned long)NULL,(unsigned char *)"Misc",USMODE_READWRITE,&hFile);

 if (SUCCEEDED(hResult))
 {

 /* IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&showMessages,sizeof(showMessages),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&always_run,sizeof(always_run),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&swap_stereo,sizeof(swap_stereo),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&mvert,sizeof(mvert),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&keylink,sizeof(keylink),&ulRead);*/
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&usejoystick,sizeof(usejoystick),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joybfire,sizeof(joybfire),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joybstrafe,sizeof(joybstrafe),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joybuse,sizeof(joybuse),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joybspeed,sizeof(joybspeed),&ulRead);
 /* IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joyb1,sizeof(joyb1),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joyb2,sizeof(joyb2),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joyb3,sizeof(joyb3),&ulRead);
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&joyb4,sizeof(joyb4),&ulRead);*/
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&screenblocks,sizeof(screenblocks),&ulRead);
  /*IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&detailLevel,sizeof(detailLevel),&ulRead);*/
  IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&usegamma,sizeof(usegamma),&ulRead);
  /*IGameStorage_USRead(pIStorage,
   hFile,(unsigned char *)&numChannels,sizeof(numChannels),&ulRead);*/

  IGameStorage_USCloseFile(pIStorage,hFile);
  }

 //
 // Detach and close down the storage
 IGameStorage_USDetach(pIStorage,);
 IGame_USGameClose(pIGame,hGame);
 IPlayer_USPlayerClose(pIPlayer,hPlayer);

 IGameStorage_Release(pIStorage,);
 IGame_Release(pIGame);
 IPlayer_Release(pIPlayer);
 IUniversalSave_Release(pIUS);
}

#endif	// USAVE