#ifdef GL_HERETIC

#include <stdio.h>
#include <Malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "doomdef.h"
#include "r_local.h"
#include "p_spec.h"

#pragma optimize( "", off )

// DOOM_GL
#include "hu_stuff.h"
#define SHORT (short)
#define LONG (long)
extern patch_t*		hu_font[HU_FONTSIZE];
extern int		numflats;

extern GLboolean g_b3Dfx;

extern int iNbGLTextures;
extern GLuint *texobjs;
extern byte *p_bPalette;
extern int	iNbGLSprites;
extern int iMaxSizeBeforeReduction;

extern int FontABaseLump,FontBBaseLump;
extern GLuint *FontAobjs,*FontBobjs;

extern int numpatches;
extern GLboolean g_bPaletteTexture;
PROC glColorTableEXT;

GLTexture *p_stGLFontA;
int	iNbGLFontA;
GLTexArray *p_stGLFontAArray;
GLMapSprite *p_stMapFontA;
short *FontAtopoffset,*FontAoffset;

/*GLTexture *p_stGLFontB;
int	iNbGLFontB;
GLMapSprite *p_stMapFontB;*/
GLTexArray *p_stGLFontBArray;
short *FontBtopoffset,*FontBoffset;

int numFontAlumps,numFontBlumps;

#define NB_PATCHS	230
GLTexArray *p_stGLPatchArray;
short *Patchtopoffset,*Patchoffset;
int iPatchLump[NB_PATCHS];
char a_szPatchName[NB_PATCHS][9]=
{	// Menus
	"M_PAUSE",
	"M_LOADG",
	"M_LSLEFT",
	"M_LSCNTR",
	"M_LSRGHT",
	"M_SAVEG",
	"M_SVOL",
	"M_DOOM",
	"M_NEWG",
	"M_EPISOD",
	"M_OPTTTL",
	"M_GDHIGH",
	"M_GDLOW",
	"M_MSGOFF",
	"M_MSGON",
	"M_THERML",
	"M_THERMM",
	"M_THERMR",
	"M_THERMO",
	"M_CELL1",
	"M_CELL2",
	"M_NGAME",
	"M_OPTION",
	"M_QUITG",
	"M_EPI1",
	"M_EPI2",
	"M_EPI3",
	"M_EPI4",
    "M_JKILL",
    "M_ROUGH",
    "M_HURT",
    "M_ULTRA",
    "M_NMARE",
    "M_ENDGAM",
    "M_MESSG",
    "M_DETAIL",
    "M_SCRNSZ",
    "M_MSENS",
    "M_SVOL",
    "M_SFXVOL",
    "M_MUSVOL",
	"M_SKULL1",
	"M_SKULL2",
	"M_RDTHIS",		// not doom2
	// STATUS_BAR
	"STBAR",
	"STTNUM0",
	"STTNUM1",
	"STTNUM2",
	"STTNUM3",
	"STTNUM4",
	"STTNUM5",
	"STTNUM6",
	"STTNUM7",
	"STTNUM8",
	"STTNUM9",
	"STYSNUM0",
	"STYSNUM1",
	"STYSNUM2",
	"STYSNUM3",
	"STYSNUM4",
	"STYSNUM5",
	"STYSNUM6",
	"STYSNUM7",
	"STYSNUM8",
	"STYSNUM9",
	"STTPRCNT",
	"STKEYS0",
	"STKEYS1",
	"STKEYS2",
	"STKEYS3",
	"STKEYS4",
	"STKEYS5",
	"STARMS",
	"STGNUM0",
	"STGNUM1",
	"STGNUM2",
	"STGNUM3",
	"STGNUM4",
	"STGNUM5",
	"STFB0",
	"STFB1",
	"STFB2",
	"STFB3",
	"STFST00",
	"STFST01",
	"STFST02",
	"STFST10",
	"STFST11",
	"STFST12",
	"STFST20",
	"STFST21",
	"STFST22",
	"STFST30",
	"STFST31",
	"STFST32",
	"STFST40",
	"STFST41",
	"STFST42",
	"STFTR00",
	"STFTR10",
	"STFTR20",
	"STFTR30",
	"STFTR40",
	"STFTL00",
	"STFTL10",
	"STFTL20",
	"STFTL30",
	"STFTL40",
	"STFOUCH0",
	"STFOUCH1",
	"STFOUCH2",
	"STFOUCH3",
	"STFOUCH4",
	"STFEVL0",
	"STFEVL1",
	"STFEVL2",
	"STFEVL3",
	"STFEVL4",
	"STFKILL0",
	"STFKILL1",
	"STFKILL2",
	"STFKILL3",
	"STFKILL4",
	"STFGOD0",
	"STFDEAD0",
	"STTMINUS",
	// Intermissions
	"WIURH0",
	"WIURH1",
	"WISPLAT",
	"WIMINUS",
	"WINUM0",
	"WINUM1",
	"WINUM2",
	"WINUM3",
	"WINUM4",
	"WINUM5",
	"WINUM6",
	"WINUM7",
	"WINUM8",
	"WINUM9",
	"WIPCNT",
	"WIF",
	"WIENTER",
	"WIOSTK",
	"WIOSTS",
	"WISCRT2",
	"WIOBJ",
	"WIOSTI",
	"WIFRGS",
	"WICOLON",
	"WITIME",
	"WISUCKS",
	"WIPAR",
	"WIKILRS",
	"WIVCTMS",
	"WIMSTT",
	"STFST01",
	"STFDEAD0",
	"WIBP0",
	"WIBP1",
	"WIBP2",
	"WIBP3",
	// Doom I:
	"WILV00",
	"WILV01",
	"WILV02",
	"WILV03",
	"WILV04",
	"WILV05",
	"WILV06",
	"WILV07",
	"WILV08",
	"WILV10",
	"WILV11",
	"WILV12",
	"WILV13",
	"WILV14",
	"WILV15",
	"WILV16",
	"WILV17",
	"WILV18",
	"WILV20",
	"WILV21",
	"WILV22",
	"WILV23",
	"WILV24",
	"WILV25",
	"WILV26",
	"WILV27",
	"WILV28",
	"WILV30",
	"WILV31",
	"WILV32",
	"WILV33",
	"WILV34",
	"WILV35",
	"WILV36",
	"WILV37",
	"WILV38",
	// Doom II:
	"CWILV00",
	"CWILV01",
	"CWILV02",
	"CWILV03",
	"CWILV04",
	"CWILV05",
	"CWILV06",
	"CWILV07",
	"CWILV08",
	"CWILV09",
	"CWILV10",
	"CWILV11",
	"CWILV12",
	"CWILV13",
	"CWILV14",
	"CWILV15",
	"CWILV16",
	"CWILV17",
	"CWILV18",
	"CWILV19",
	"CWILV20",
	"CWILV21",
	"CWILV22",
	"CWILV23",
	"CWILV24",
	"CWILV25",
	"CWILV26",
	"CWILV27",
	"CWILV28",
	"CWILV29",
	"CWILV30",
	"CWILV31"
};

#define NB_SCREENS 11
char a_szScreenNames[NB_SCREENS][9]=
{	
	// V_DrawPatch
	"TITLEPIC",
	"HELP",
	"HELP1",
	"HELP2",
	"CREDIT",
	"INTERPIC",
	"WIMAP0",
	"WIMAP1",
	"WIMAP2",
	"VICTORY2",
	"ENDPIC"
	// V_DrawRawScreen
};

#define MNU_X(x)		(int)((float)(x)*SCREENWIDTH/320.0f)
#define MNU_Y(y)		(int)((float)(y)*SCREENHEIGHT/200.0f)
extern float fScaleSprite;

void fn_vRegisterPatchs()
{ patch_t *patch;
  int i;
  int iPrevMax;
  float fPrevScale;

	fPrevScale=fScaleSprite;
	iPrevMax=iMaxSizeBeforeReduction;
	iMaxSizeBeforeReduction=0x7fffffff;

	p_stGLPatchArray=(GLTexArray *)Malloc(NB_PATCHS*sizeof(GLTexArray));

	for (i=0;i<NB_PATCHS;i++)
		p_stGLPatchArray[i].iTexID=-1;

	Patchtopoffset=(short *)Malloc(NB_PATCHS*sizeof(short));
	Patchoffset=(short *)Malloc(NB_PATCHS*sizeof(short));
	for (i=0;i<NB_PATCHS;i++)
	{	
		/*if (shareware&&
			(!strcmp(a_szPatchName[i],"ARTISPHL")||!strcmp(a_szPatchName[i],"ARTIATLP")||
			!strcmp(a_szPatchName[i],"INAMRAM")||!strcmp(a_szPatchName[i],"INAMPNX")||
			!strcmp(a_szPatchName[i],"INAMLOB")))	// shareware
			continue;*/

		if (W_CheckNumForName(a_szPatchName[i])==-1)		// DOOM_GL: shareware...
			continue;
		
		iPatchLump[i]=W_GetNumForName(a_szPatchName[i]);
		patch = W_CacheLumpNum(iPatchLump[i], PU_CACHE);
		Patchtopoffset[i]=patch->topoffset;
		Patchoffset[i]=patch->leftoffset;
		
/*		if (patch->width>256)
			printf("prout\n");*/

		if (g_b3Dfx)
		{	if ((!strcmp(a_szPatchName[i],"STBAR"))/*||(!strcmp(a_szPatchName[i],"CHAINBACK"))*/)
			{	iMaxSizeBeforeReduction=2;
				fScaleSprite=0.8f;
			}
			else
			/*if (!strcmp(a_szPatchName[i],"CHAIN"))
			{	iMaxSizeBeforeReduction=2;
				fScaleSprite=256.0f/296.0f;
			}
			else*/
				iMaxSizeBeforeReduction=65536;
		}
		if (!strcmp(a_szPatchName[i],"M_EPI1"))
		{	iMaxSizeBeforeReduction=2;
			fScaleSprite=256.0f/263.0f;
		}

		if (patch->width>256)
			iMaxSizeBeforeReduction=patch->width*patch->height-1;
		fn_vRegisterSpriteCompressed(&p_stGLFontA,&p_stMapFontA,&p_stGLPatchArray,i,patch);
		if (patch->width>256)
			iMaxSizeBeforeReduction=0x7fffffff;
	}
	iNbGLFontA=iNbGLSprites;
//	fn_vSaveRAW("bar0.raw",p_stGLFontA[0].p_bRGBBuffer,128,128);
//	fn_vSaveRAW("bar1.raw",p_stGLFontA[1].p_bRGBBuffer,256,128);
//	fn_vSaveRAW("bar2.raw",p_stGLFontA[2].p_bRGBBuffer,256,128);

	iMaxSizeBeforeReduction=iPrevMax;
	fScaleSprite=fPrevScale;
}

int GL_GetNumForName(char *szName)
{ int i;

	for (i=0;i<NB_PATCHS;i++)
		if (!stricmp(szName,a_szPatchName[i]))
			return i;
	return -1;
}

void GL_DrawCompressedPatch(int x, int y, int iWidth, int iHeight,int iLump)
// For 3Dfx (Max texture size is 256x256)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,i;

		if (iLump==-1)
			return;	// Patch not registered
		i=iLump;
		{
			x=MNU_X(x);
			y=MNU_Y(y);

			y -= SHORT(MNU_Y(Patchtopoffset[i]));
			x -= SHORT(MNU_X(Patchoffset[i]));

			iTexIndex=p_stGLPatchArray[i].iGLTexIndex;
			iSubTex=p_stGLPatchArray[i].iUVIndex;
			fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
			fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
			fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
			fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
			iWidth=MNU_X(iWidth);
			iHeight=MNU_Y(iHeight);


			glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

			glBegin(GL_QUADS);
				glTexCoord2f(fU1, fV1); glVertex2i( x, SCREENHEIGHT-1-y );
				glTexCoord2f(fU1, fV2); glVertex2i( x, SCREENHEIGHT-1-y-iHeight );
				glTexCoord2f(fU2, fV2); glVertex2i( x+iWidth, SCREENHEIGHT-1-y-iHeight );
				glTexCoord2f(fU2, fV1); glVertex2i( x+iWidth, SCREENHEIGHT-1-y );
			glEnd();
		}
}

int GL_iPatchWidth(int lump)
{ int iTexIndex=p_stGLPatchArray[lump].iGLTexIndex;
  int iSubTex=p_stGLPatchArray[lump].iUVIndex;

	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth;
}

int GL_iPatchHeight(int lump)
{ int iTexIndex=p_stGLPatchArray[lump].iGLTexIndex;
  int iSubTex=p_stGLPatchArray[lump].iUVIndex;

	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight;
}

void GL_DrawPatch(int x, int y, int iLump)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight,i;

	/*for (i=0;i<NB_PATCHS;i++)
		if (iPatchLump[i]==iLump)*/
		if (iLump==-1)
			return;	// Patch not registered
		i=iLump;
		{
			x=MNU_X(x);
			y=MNU_Y(y);

			y -= SHORT(MNU_Y(Patchtopoffset[i]));
			x -= SHORT(MNU_X(Patchoffset[i]));
/*			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			glOrtho( (GLdouble) 0, (GLdouble) SCREENWIDTH, (GLdouble) 0, (GLdouble) SCREENHEIGHT, (GLdouble) -1.0, (GLdouble) 1.0 );

			glDisable(GL_DEPTH_TEST);
			glEnable(GL_ALPHA_TEST);
			glAlphaFunc(GL_EQUAL,1.0f);*/

			iTexIndex=p_stGLPatchArray[i].iGLTexIndex;
			iSubTex=p_stGLPatchArray[i].iUVIndex;
			fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
			fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
			fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
			fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
			iWidth=MNU_X(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth);
			iHeight=MNU_Y(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight);

			glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

			glBegin(GL_QUADS);
				glTexCoord2f(fU1, fV1); glVertex2i( x, SCREENHEIGHT-1-y );
				glTexCoord2f(fU1, fV2); glVertex2i( x, SCREENHEIGHT-1-y-iHeight );
				glTexCoord2f(fU2, fV2); glVertex2i( x+iWidth, SCREENHEIGHT-1-y-iHeight );
				glTexCoord2f(fU2, fV1); glVertex2i( x+iWidth, SCREENHEIGHT-1-y );
			glEnd();

/*			glEnable(GL_DEPTH_TEST);
			glDisable(GL_ALPHA_TEST);*/
//			break;
		}
}

void GL_DrawShadowedPatch(int x, int y, int iLump)
{
	glColor3f(0.5f,0.5f,0.5f);
	GL_DrawShadowedPatch(x,y,iLump);
	glColor3f(1.0f,1.0f,1.0f);
}

GLboolean g_bInitFonts=false;
GLvoid fn_vGLInitFonts()
{ patch_t *patch;
  int i;

	g_bInitFonts=true;
	SPRITE_WIDTH=128;
	SPRITE_HEIGHT=128;
	//numFontAlumps=W_GetNumForName("FONTA_E")-W_GetNumForName("FONTA_S");
	//numFontBlumps=W_GetNumForName("FONTB_E")-W_GetNumForName("FONTB_S");
	numFontAlumps=HU_FONTSIZE;

	p_stGLFontA=(GLTexture *)Malloc(sizeof(GLTexture));
	p_stMapFontA=(GLMapSprite *)Malloc(sizeof(GLMapSprite));
	p_stGLFontAArray=(GLTexArray *)Malloc(numFontAlumps*sizeof(GLTexArray));
	for (i=0;i<numFontAlumps;i++)
		p_stGLFontAArray[i].iTexID=-1;
	p_bPalette=W_CacheLumpName("PLAYPAL", PU_STATIC);

	/*p_stGLFontBArray=(GLTexArray *)Malloc(numFontBlumps*sizeof(GLTexArray));
	for (i=0;i<numFontBlumps;i++)
		p_stGLFontBArray[i].iTexID=-1;*/

	FontAtopoffset=(short *)Malloc(numFontAlumps*sizeof(short));
	FontAoffset=(short *)Malloc(numFontAlumps*sizeof(short));
	iNbGLSprites=0;
	for (i=0;i<numFontAlumps;i++)
	{	//patch = W_CacheLumpNum(FontABaseLump+i, PU_CACHE);
		patch = hu_font[i];
		FontAtopoffset[i]=patch->topoffset;
		FontAoffset[i]=patch->leftoffset;
		fn_vRegisterSpriteCompressed(&p_stGLFontA,&p_stMapFontA,&p_stGLFontAArray,i,patch);
	}

/*	FontBtopoffset=(short *)Malloc(numFontBlumps*sizeof(short));
	FontBoffset=(short *)Malloc(numFontBlumps*sizeof(short));
//	iNbGLSprites=0;
	for (i=0;i<numFontBlumps-1;i++)	// Why -1 ???
	{	patch = W_CacheLumpNum(FontBBaseLump+i, PU_CACHE);
		FontBtopoffset[i]=patch->topoffset;
		FontBoffset[i]=patch->leftoffset;
		//fn_vRegisterSpriteCompressed(&p_stGLFontB,&p_stMapFontB,&p_stGLFontBArray,i,patch);
		fn_vRegisterSpriteCompressed(&p_stGLFontA,&p_stMapFontA,&p_stGLFontBArray,i,patch);
	}
//	iNbGLFontB=iNbGLSprites;*/
	iNbGLFontA=iNbGLSprites;

	// Register other patchs...
	fn_vRegisterPatchs();
	
	iNbGLSprites=0;

	SPRITE_WIDTH=SPRITE_HEIGHT=128;
	g_bInitFonts=false;
}

int GL_DrawLetterA(int x,int y,int lump)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight;

	// DOOM_GL
	x=MNU_X(x);
	y=MNU_Y(y);

	y -= SHORT(MNU_Y(FontAtopoffset[lump]));
	x -= SHORT(MNU_X(FontAoffset[lump]));

	iTexIndex=p_stGLFontAArray[lump].iGLTexIndex;
	iSubTex=p_stGLFontAArray[lump].iUVIndex;
	fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
	fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
	fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
	fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
	iWidth=MNU_X(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth);
	iHeight=MNU_Y(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight);

	glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

	glBegin(GL_QUADS);
		glTexCoord2f(fU1, fV1); glVertex2i( x, SCREENHEIGHT-1-y );
		glTexCoord2f(fU1, fV2); glVertex2i( x, SCREENHEIGHT-1-y-iHeight );
		glTexCoord2f(fU2, fV2); glVertex2i( x+iWidth, SCREENHEIGHT-1-y-iHeight );
		glTexCoord2f(fU2, fV1); glVertex2i( x+iWidth, SCREENHEIGHT-1-y );
	glEnd();

	//return iWidth;
	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth;
}

/*void GL_DrTextA(char *text, int x, int y)
{
	char c;
	int width;

	while((c = *text++) != 0)
	{
		if(c < 33)
		{
			x += 5;
		}
		else
		{
			width=GL_DrawLetterA(MNU_X(x), MNU_Y(y), c-33);
			x += width-1;
		}
	}
}

int GL_DrawLetterB(int x,int y,int lump)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight;

	y -= SHORT(MNU_Y(FontBtopoffset[lump]));
	x -= SHORT(MNU_X(FontBoffset[lump]));

	iTexIndex=p_stGLFontBArray[lump].iGLTexIndex;
	iSubTex=p_stGLFontBArray[lump].iUVIndex;

	fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
	fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
	fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
	fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
	iWidth=MNU_X(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth);
	iHeight=MNU_Y(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight);

	glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

	glBegin(GL_QUADS);
		glTexCoord2f(fU1, fV1); glVertex2i( x, SCREENHEIGHT-1-y );
		glTexCoord2f(fU1, fV2); glVertex2i( x, SCREENHEIGHT-1-y-iHeight );
		glTexCoord2f(fU2, fV2); glVertex2i( x+iWidth, SCREENHEIGHT-1-y-iHeight );
		glTexCoord2f(fU2, fV1); glVertex2i( x+iWidth, SCREENHEIGHT-1-y );
	glEnd();

	//return iWidth;
	//return p_stGLFontB[iTexIndex].a_stSubTex[iSubTex].iWidth;
	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth;
}

int GL_DrawShadowedLetterB(int x,int y,int lump)
{ int width;

	glColor3f(0.5f,0.5f,0.5f);
	width=GL_DrawLetterB(MNU_X(x),MNU_Y(y),lump);
	glColor3f(1.0f,1.0f,1.0f);

	return width;
}

void GL_DrTextB(char *text, int x, int y)
{
	char c;
	int width;


	while((c = *text++) != 0)
	{
		if(c < 33)
		{
			x += 8;
		}
		else
		{
			width=GL_DrawLetterB(MNU_X(x), MNU_Y(y), c-33);
			x += width-1;
		}
	}

}*/

// For the MAP
GLvoid GL_DrawLine(int X0, int Y0, int X1, int Y1, byte BaseColor)
{
	glDisable(GL_TEXTURE_2D);
/*	glLineWidth(2);
	glEnable(GL_LINE_SMOOTH);*/
	glColor3f((float)p_bPalette[3*BaseColor]/255.0f,(float)p_bPalette[3*BaseColor+1]/255.0f,(float)p_bPalette[3*BaseColor+2]/255.0f);
	glBegin(GL_LINES);
		glVertex2i( X0, SCREENHEIGHT-1-Y0 );
		glVertex2i( X1, SCREENHEIGHT-1-Y1 );
	glEnd();
	glEnable(GL_TEXTURE_2D);
}

GLvoid GL_DumpScreen()
{ 
/*	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	GLSet2DMode();
	glEnable(GL_TEXTURE_2D);*/
	glColor3f(1.0f,1.0f,1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glRasterPos2i(0,0);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glDrawPixels(SCREENWIDTH,SCREENHEIGHT,GL_COLOR_INDEX8_EXT,GL_UNSIGNED_BYTE,screen);
	}
	else
#endif
		glDrawPixels(SCREENWIDTH,SCREENHEIGHT,GL_RGB,GL_UNSIGNED_BYTE,screen);
	glEnable(GL_TEXTURE_2D);
	glColor3f(1.0f,1.0f,1.0f);
}

unsigned char *p_bRGBTitle1[NB_SCREENS],*p_bRGBTitle2[NB_SCREENS];
int iGlObjTITLE;

GLvoid GL_RegisterPatchScreen(int i)
{ int x=0,y=0;
	int count;
	int col;
	column_t *column;
	byte *source;
	int w;
	patch_t *patch;

	if (W_CheckNumForName(a_szScreenNames[i])==-1)		// shareware...
		return;
	patch=(patch_t *)W_CacheLumpName(a_szScreenNames[i],PU_CACHE);
	w = SHORT(patch->width);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	p_bRGBTitle1[i]=(unsigned char *)Malloc(256*256);
		for (col=0;col<256;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle1[i][col+y*256]=*source;
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
/*			source=(byte *)column+3;
			for (y=0;y<200;y++)
				p_bRGBTitle1[i][col+y*256]=source[y];*/
		}
		p_bRGBTitle2[i]=(unsigned char *)Malloc(64*256);
		for (col=256;col<320;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle2[i][col-256+y*64]=*source;
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
/*			source=(byte *)column+3;
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][col-256+y*64]=source[y];
			}*/
		}
	}
	else
#endif
	{
		p_bRGBTitle1[i]=(unsigned char *)Malloc(256*256*3);
		for (col=0;col<256;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle1[i][3*(col+y*256)]=p_bPalette[3**source];
					p_bRGBTitle1[i][3*(col+y*256)+1]=p_bPalette[3**source+1];
					p_bRGBTitle1[i][3*(col+y*256)+2]=p_bPalette[3**source+2];
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
			/*source=(byte *)column+3;
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][3*(col+y*256)]=p_bPalette[3*source[y]];
				p_bRGBTitle1[i][3*(col+y*256)+1]=p_bPalette[3*source[y]+1];
				p_bRGBTitle1[i][3*(col+y*256)+2]=p_bPalette[3*source[y]+2];
				//p_bRGBTitle1[i][4*(x+y*256)+3]=255;
			}*/
		}
		p_bRGBTitle2[i]=(unsigned char *)Malloc(64*256*3);
		for (col=256;col<320;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{ 
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle2[i][3*(col-256+y*64)]=p_bPalette[3**source];
					p_bRGBTitle2[i][3*(col-256+y*64)+1]=p_bPalette[3**source+1];
					p_bRGBTitle2[i][3*(col-256+y*64)+2]=p_bPalette[3**source+2];
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
			/*source=(byte *)column+3;
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][3*(col-256+y*64)]=p_bPalette[3*source[y]];
				p_bRGBTitle2[i][3*(col-256+y*64)+1]=p_bPalette[3*source[y]+1];
				p_bRGBTitle2[i][3*(col-256+y*64)+2]=p_bPalette[3*source[y]+2];
				//p_bRGBTitle2[i][4*(x-256+y*64)+3]=255;
			}*/
		}
	}

	iGlObjTITLE = numspritelumps+numflats+numpatches+iNbGLFontA+1;
	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
/*#ifdef BILINEAR
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 256, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);

	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i+1);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
/*#ifdef BILINEAR
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 64, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
}
		
/*GLvoid GL_DrawPatchScreen(patch_t *patch)
{ int x=0,y=0;
	int count;
	int col;
	column_t *column;
	byte *desttop;
	byte *dest;
	byte *source;
	int w;

	col = 0;
	desttop = screen+y*SCREENWIDTH+x;
	w = SHORT(patch->width);
	for(; col < w; x++, col++, desttop++)
	{
		column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
		// Step through the posts in a column
		while(column->topdelta != 0xff)
		{
			source = (byte *)column+3;
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
				dest = desttop+column->topdelta*SCREENWIDTH;
			else
#endif
				dest = desttop+column->topdelta*SCREENWIDTH*3;
			count = column->length;
			while(count--)
			{
#ifdef PALETTED_TEXTURE
				if (g_bPaletteTexture)
				{
					*dest = *source++;
					dest += SCREENWIDTH;
				}
				else
#endif
				{	int y;
					*dest=p_bPalette[3*(*source)];
					*(dest+1)=p_bPalette[3*(*source)+1];
					*(dest+2)=p_bPalette[3*(*source++)+2];
					dest += 3*SCREENWIDTH;
				}
			}
			column = (column_t *)((byte *)column+column->length+4);
		}
	}
	GL_DumpScreen();
}*/

GLvoid GLDrawScreen(int i)
{ 	
	glEnable(GL_TEXTURE_2D);
	glColor3f(1.0f,1.0f,1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glBindTexture(GL_TEXTURE_2D,iGlObjTITLE+2*i);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0,0);
	glEnd();
	glBindTexture(GL_TEXTURE_2D,iGlObjTITLE+2*i+1);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f((float)SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f((float)SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
	glEnd();
}

GLvoid GLDrawScreenFromName(char *name)
{ int i;
	for (i=0;i<NB_SCREENS;i++)
		if (!strcmp(name,a_szScreenNames[i]))
			break;
	if (i==NB_SCREENS)
		return;

	GLDrawScreen(i);
}

GLvoid GLRegisterScreen(int i)	// 2 textures for one 320x200 screen because of the 3Dfx limitations (256x256)
{ byte *patch;
  int x,y;
	
	patch=(byte *)W_CacheLumpName(a_szScreenNames[i],PU_CACHE);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	p_bRGBTitle1[i]=(unsigned char *)Malloc(256*256);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][x+y*256]=patch[x+y*320];
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)Malloc(64*256);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][x-256+y*64]=patch[x+y*320];
			}
		}
	}
	else
#endif
	{
		p_bRGBTitle1[i]=(unsigned char *)Malloc(256*256*3);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][3*(x+y*256)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle1[i][3*(x+y*256)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle1[i][3*(x+y*256)+2]=p_bPalette[3*patch[x+y*320]+2];
				//p_bRGBTitle1[i][4*(x+y*256)+3]=255;
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)Malloc(64*256*3);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][3*(x-256+y*64)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle2[i][3*(x-256+y*64)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle2[i][3*(x-256+y*64)+2]=p_bPalette[3*patch[x+y*320]+2];
				//p_bRGBTitle2[i][4*(x-256+y*64)+3]=255;
			}
		}
	}

	iGlObjTITLE = numspritelumps+numflats+numpatches+iNbGLFontA+1;
	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
/*#ifdef BILINEAR
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 256, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);

	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i+1);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
/*#ifdef BILINEAR
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 64, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
}

GLvoid GLRegisterScreens()
{
// DOOM_GL: A VOIR
/*	GLRegisterScreen(0);
	if (shareware)
		GLRegisterScreen(1);
	GLRegisterScreen(2);
	GLRegisterScreen(3);
	GLRegisterScreen(4);

	GL_RegisterPatchScreen(5);
	if (!shareware)
	{	GL_RegisterPatchScreen(6);
		GL_RegisterPatchScreen(7);
	}*/
	GL_RegisterPatchScreen(0);
	GL_RegisterPatchScreen(1);
	GL_RegisterPatchScreen(2);
	GL_RegisterPatchScreen(3);
	GL_RegisterPatchScreen(4);
	// Inter missions...	
	GL_RegisterPatchScreen(6);
	if ((gamemode==commercial)||(gamemode==retail))
		GL_RegisterPatchScreen(5);
	if ((gamemode==retail)||(gamemode==registered))
	{	GL_RegisterPatchScreen(7);
		GL_RegisterPatchScreen(8);
	}
}

void GL_DrawStatBack(char *name)
{
	int x;
	int y;
	int i;

	byte *src;
	byte *dest;

	src = W_CacheLumpName (name, PU_CACHE);
	dest = screen;

	for (y=0 ; y<SCREENHEIGHT ; y++)
	{
		for (x=0 ; x<SCREENWIDTH/64 ; x++)
		{
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
			{	memcpy (dest, src+((y&63)<<6), 64);
				dest += 64;
			}
			else
#endif
			for (i=0;i<64;i++)
			{	dest[3*(64*x+i+SCREENWIDTH*y)]=p_bPalette[3*src[i+((y&63)<<6)]];
				dest[3*(64*x+i+SCREENWIDTH*y)+1]=p_bPalette[3*src[i+((y&63)<<6)]+1];
				dest[3*(64*x+i+SCREENWIDTH*y)+2]=p_bPalette[3*src[i+((y&63)<<6)]+2];
			}
		}
		if (SCREENWIDTH&63)
		{
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
			{	memcpy (dest, src+((y&63)<<6), SCREENWIDTH&63);
				dest += (SCREENWIDTH&63);
			}
			else
#endif
			for (i=0;i<SCREENWIDTH&63;i++)
			{	dest[3*(64*x+i+SCREENWIDTH*y)]=p_bPalette[3*src[i+((y&63)<<6)]];
				dest[3*(64*x+i+SCREENWIDTH*y)+1]=p_bPalette[3*src[i+((y&63)<<6)]+1];
				dest[3*(64*x+i+SCREENWIDTH*y)+2]=p_bPalette[3*src[i+((y&63)<<6)]+2];
			}
		}
	}
	GL_DumpScreen();
//	free(screen);
}

#endif GL_HERETIC
